/*
 *          File: stacktest.c
 *        Author: Robert I. Pitts <rip@cs.bu.edu>
 */
#include <stdio.h>
#include <string.h>  /* for strlen() */
#include "stack.h"
#include <stdlib.h>  /* for dynamic allocation */
 
/************************ Funktsioonid **********************/

void StackInit(stackT *stackP, int maxSize)
{
  stackElementT *newContents;

  /* uus  */

  newContents = (stackElementT *)malloc(sizeof(stackElementT) * maxSize);

  if (newContents == NULL) {
    fprintf(stderr, "Ei ole piisavalt ruumi pinule\n");
    exit(1);  /* Lahkun veateatega */
  }

  stackP->contents = newContents;
  stackP->maxSize = maxSize;
  stackP->top = -1;  /* tyhi */
}

void StackDestroy(stackT *stackP)
{
  /* massiivi kaotamine */
  free(stackP->contents);

  stackP->contents = NULL;
  stackP->maxSize = 0;
  stackP->top = -1;  /* tyhi*/
}

void StackPush(stackT *stackP, stackElementT element)
{
  if (StackIsFull(stackP)) {
    fprintf(stderr, "Ei saa elemente panna pinusse - on tis\n");
    exit(1);  /* Lahkun veateatega */
  }

  /* Panen elemendi pinusse,massiivi */

  stackP->contents[++stackP->top] = element;
  
}

stackElementT StackPop(stackT *stackP)
{
  if (StackIsEmpty(stackP)) {
    fprintf(stderr, "Ei saa elemente pinust votta - on tyhi\n");
    exit(1);  /*  Lahkun,vea teade */
  }

  return stackP->contents[stackP->top--];
}

int StackIsEmpty(stackT *stackP)
{
  return stackP->top < 0;
}

int StackIsFull(stackT *stackP)
{
  return stackP->top >= stackP->maxSize - 1;
}
/************************ Peaprogramm **********************/
int main(void)
{
  stackT stack;    /* pinu symbolitele,stringile */
  char str[101];   /* kasutaja strigile muutuja kirjeldus */
  char *traverse;  /* viit strigis liikumiseks */

  /*
   * stringi sisestus
   * mitte rohkem kui 100 symbolit
   */
  printf("Sisesta string: ");

  gets(str);  /* loe rida */

  /*
   * Initializeeri pinu ja seda piisavalt suurena.
   */
  StackInit(&stack, strlen(str));

  /*
   * Liigu strigi pidi ja aseta iga symbol pinusse
   */

  for (traverse = str; *traverse != '\0'; traverse++) {
    StackPush(&stack, *traverse);
    printf("%c", *traverse);
    printf("\n");
    /*pinusse tulekud*/ 
  }

  /*
   * Vota iga symbol pinust ja prindi
   */

  printf("\nPinust  valjastatud symbolid: ");

  while (!StackIsEmpty(&stack)) {
    printf("%c", StackPop(&stack));
  }

  printf("\n");

  StackDestroy(&stack);
   getchar();
  return 0;
}
